var jsKeyboard = {
	
    settings: {
        buttonClass: "button", // default button class
        onclick: "jsKeyboard.write();", // default onclick event for button
        keyClass: "key", // default key class used to define style of text of the button
        text: {
            close: "close"
        }
    },
	width:800,
    margin:3,
    backSpaceWidth:80,
    "keyboard": [], // different keyboards can be set to this variable in order to switch between keyboards easily.
    init: function(elem, keyboard, width, callback) {
		if(width!=undefined)
			jsKeyboard.width = width;
        jsKeyboard.keyboard["default"] = jsKeyboard.defaultKeyboard;
        jsKeyboard.keyboardLayout = elem;



        if (keyboard != null && keyboard != undefined)
            jsKeyboard.generateKeyboard(keyboard);
        else
            jsKeyboard.generateKeyboard("default");

        jsKeyboard.addKeyDownEvent();

         jsKeyboard.show();
         $(':input').not('[type="reset"]').not('[type="submit"]').on('focus, click', function(e)
         {
            jsKeyboard.currentElement = $(this);
            jsKeyboard.currentElementCursorPosition = $(this).getCursorPosition();
            console.log('keyboard is now focused on '+jsKeyboard.currentElement.attr('name')+' at pos('+jsKeyboard.currentElementCursorPosition+')');
         });
        if(callback)
            callback();
    },
    focus: function(t) {
        jsKeyboard.currentElement = $(t);
        jsKeyboard.show();
    },
    keyboardLayout: "", // it shows the html element where keyboard is generated
    currentKeyboard: "default", // it shows the which keyboard is used. If it's not set default keyboard is used.
    currentElement: null,
    generateKeyboard: function(keyboard) {
        var bClass = "";
        var kClass = "";
        var onclick = "";
        var text = "";

        var nKeys = 11;
        var btnWidth = (jsKeyboard.width-nKeys*jsKeyboard.margin)/nKeys;
        var btnHeight = btnWidth;
        if(btnWidth<30)
            btnHeight = 30;
        var s = "";
        s += "<div id=\"keyboard\" style=\"width:"+jsKeyboard.width+"px\">";
        s += "<div id=\"keyboardHeader\">";
        // s += "<div onclick=\"jsKeyboard.hide();\"><span>" + jsKeyboard.settings.text.close + "</span><span class=\"closex\"> X</span></div>"
        s += "</div>";

		/*Arabic letter*/
        s += "<div id=\"keyboardArabicLetter\">";
        $.each(jsKeyboard.keyboard[keyboard].arabicLetter, function(i, key) {
            generate(key,btnWidth,"ar", 11, btnHeight);
        });
        s += "</div>";


        function generate(key, btnWidth, lang,nBtn,btnHeight) {
            bClass = key.buttonClass == undefined ? jsKeyboard.settings.buttonClass : key.buttonClass;
            kClass = key.keyClass == undefined ? jsKeyboard.settings.keyClass : key.keyClass;
            if(key.isStr==true)
                onclick = key.onclick == undefined ? jsKeyboard.settings.onclick.replace("()", "('" + key.value + "')") : key.onclick;
            else
                onclick = key.onclick == undefined ? jsKeyboard.settings.onclick.replace("()", "('" + String.fromCharCode(key.value) + "')") : key.onclick;

            if(key.img != undefined)
                text = "<img src='img/"+key.img+"' style='width:25%;' />";
            else
                text = (key.isChar != undefined || key.isChar == false || key.isStr==true) ? key.value : String.fromCharCode(key.value);
            //if(key.)
			if(nBtn==undefined)
				nBtn = 10;
            //var nBtn = 10;
            //if(lang=="ar")
             //   nBtn = 11;
            //if(key.type=="BKSPC")
              //  btnWidth = jsKeyboard.width-btnWidth*nBtn-(nBtn+1)*jsKeyboard.margin;


            var widthStyle = ' style="width:'+btnWidth+'px;height:'+btnHeight+'px" ';
            s += "<div class=\"" + bClass +"\"" + widthStyle + " ><div class=\"" + kClass + "\">" + text + "</div></div>";

            bClass = ""; kClass = ""; onclick = ""; text = "";
        }

        $("#" + jsKeyboard.keyboardLayout).html(s);
        $(".button_ar").bind("touchstart",function(){
            localStorage.st = Date.now();
            var btn = $(this);
            //setTimeout(function() {
                playSound( 'tab4' );
            //},0);
            insertChar(btn.find(".key").text(), currentNet);


        });
        $(".button_del").bind("touchstart",function(){
            playSound( 'tab4' );
            deleteChar(currentNet);
        });
    },
    addKeyDownEvent: function() {
        $("#keyboardCapitalLetter > div.button, #keyboardSmallLetter > div.button, #keyboardNumber > div.button, #keyboardSymbols > div.button, #keyboardArabicLetter > div.button, #keyboardArabicDiacritic > div.button, #keyboardArabicNumber > div.button, #keyboardArabicSymbols > div.button").
            bind('mousedown', (function() { $(this).addClass("buttonDown"); })).
            bind('mouseup', (function() { $(this).removeClass("buttonDown"); })).
            bind('mouseout', (function() { $(this).removeClass("buttonDown"); }));

            //key focus down on actual keyboard key presses
            //todo:....

    },
    changeToSmallLetter: function() {
        $("#keyboardCapitalLetter,#keyboardNumber,#keyboardSymbols,#keyboardArabicLetter,#keyboardArabicDiacritic,#keyboardArabicNumber,#keyboardArabicSymbols").css("display", "none");
        $("#keyboardSmallLetter").css("display", "block");
    },
    changeToCapitalLetter: function() {
        $("#keyboardCapitalLetter").css("display", "block");
        $("#keyboardSmallLetter,#keyboardNumber,#keyboardSymbols,#keyboardArabicLetter,#keyboardArabicDiacritic,#keyboardArabicNumber,#keyboardArabicSymbols").css("display", "none");
    },
    changeToNumber: function() {
        $("#keyboardNumber").css("display", "block");
        $("#keyboardSymbols,#keyboardCapitalLetter,#keyboardSmallLetter,#keyboardArabicLetter,#keyboardArabicDiacritic,#keyboardArabicNumber,#keyboardArabicSymbols").css("display", "none");
    },
	changeToArabicLetter: function(){
        $("#keyboardCapitalLetter,#keyboardNumber,#keyboardSmallLetter,#keyboardSymbols,#keyboardArabicDiacritic,#keyboardArabicNumber,#keyboardArabicSymbols").css("display", "none");
        $("#keyboardArabicLetter").css("display", "block");
	},
    changeToSymbols: function() {
        $("#keyboardCapitalLetter,#keyboardNumber,#keyboardSmallLetter,#keyboardArabicLetter,#keyboardArabicDiacritic,#keyboardArabicNumber,#keyboardArabicSymbols").css("display", "none");
        $("#keyboardSymbols").css("display", "block");
    },
    changeToArabicDiacritic: function() {
        $("#keyboardCapitalLetter,#keyboardNumber,#keyboardSmallLetter,#keyboardArabicLetter").css("display", "none");
        $("#keyboardArabicDiacritic").css("display", "block");
    },
    changeToArabicNumber: function() {
        $("#keyboardCapitalLetter,#keyboardNumber,#keyboardSmallLetter,#keyboardArabicLetter,#keyboardArabicSymbols,#keyboardArabicDiacritic").css("display", "none");
        $("#keyboardArabicNumber").css("display", "block");
    },
    changeToArabicSymbols: function() {
        $("#keyboardCapitalLetter,#keyboardNumber,#keyboardSmallLetter,#keyboardArabicLetter,#keyboardArabicNumber").css("display", "none");
        $("#keyboardArabicSymbols").css("display", "block");
    },
    updateCursor: function()
    {
        //input cursor focus and position during typing
        jsKeyboard.currentElement.setCursorPosition(jsKeyboard.currentElementCursorPosition);
    },
    write: function(m) {
        var a = jsKeyboard.currentElement.val(),
            b = m,//String.fromCharCode(m),
            pos = jsKeyboard.currentElementCursorPosition,
            output = [a.slice(0, pos), b, a.slice(pos)].join('');
        jsKeyboard.currentElement.val(output);
        jsKeyboard.currentElementCursorPosition+= b.length; //+1 cursor
        jsKeyboard.updateCursor();
    },
    del: function() {
        var a = jsKeyboard.currentElement.val(),
            pos = jsKeyboard.currentElementCursorPosition,
            output = [a.slice(0, pos-1), a.slice(pos)].join('');
        jsKeyboard.currentElement.val(output);
        jsKeyboard.currentElementCursorPosition--; //-1 cursor
        jsKeyboard.updateCursor();
    },
    enter: function() {
        var t = jsKeyboard.currentElement.val();
        jsKeyboard.currentElement.val(t + "\n");
    },
    space: function() {
        var a = jsKeyboard.currentElement.val(),
            b = " ",
            pos = jsKeyboard.currentElementCursorPosition,
            output = [a.slice(0, pos), b, a.slice(pos)].join('');
        jsKeyboard.currentElement.val(output);
        jsKeyboard.currentElementCursorPosition++; //+1 cursor
        jsKeyboard.updateCursor();
    },
    writeSpecial: function(m) {
        var a = jsKeyboard.currentElement.val(),
            b = String.fromCharCode(m),
            pos = jsKeyboard.currentElementCursorPosition,
            output = [a.slice(0, pos), b, a.slice(pos)].join('');
        jsKeyboard.currentElement.val(output);
        jsKeyboard.currentElementCursorPosition++; //+1 cursor
        jsKeyboard.updateCursor();
    },
    show: function() {
        $("#keyboard").animate({ "bottom": "0" }, "slow", function() { });
    },
    hide: function() {
        $("#keyboard").animate({ "bottom": "-350px" }, "slow", function() { });
    },
    defaultKeyboard: {
		//******************************* Arabic *********************************
        arabicLetter:
            [
        // 1st row
				{ value: 0x636, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x635, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x62b, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x642, buttonClass: "button button_ar",keyClass:"key key_ar"},
				{ value: 0x641, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x63a, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x639, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x647, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x62e, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x62d, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x62c, buttonClass: "button button_ar",keyClass:"key key_ar" },
        // 2nd row
               { value: 0x634, buttonClass: "button button_ar",keyClass:"key key_ar" },
			   { value: 0x633, buttonClass: "button button_ar",keyClass:"key key_ar" },
			   { value: 0x64a, buttonClass: "button button_ar",keyClass:"key key_ar" },
			   { value: 0x628, buttonClass: "button button_ar",keyClass:"key key_ar" },
               { value: 0x644, buttonClass: "button button_ar",keyClass:"key key_ar" },
			   { value: 0x627, buttonClass: "button button_ar",keyClass:"key key_ar" },
			   { value: 0x62a, buttonClass: "button button_ar",keyClass:"key key_ar" },
			   { value: 0x646, buttonClass: "button button_ar",keyClass:"key key_ar" },
			   { value: 0x645, buttonClass: "button button_ar",keyClass:"key key_ar" },
			   { value: 0x643, buttonClass: "button button_ar",keyClass:"key key_ar" },
			   { value: 0x637, buttonClass: "button button_ar",keyClass:"key key_ar" },
        // 3rd row
				{ value: 0x630, buttonClass: "button button_ar",keyClass:"key key_ar" },
                { value: 0x626, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x621, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x624, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x631, buttonClass: "button button_ar",keyClass:"key key_ar" },
                { value: 0x649, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x648, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x632, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x638, buttonClass: "button button_ar",keyClass:"key key_ar" },
				{ value: 0x62f, buttonClass: "button button_ar",keyClass:"key key_ar" },
                { value: "مسح", isChar: "false", onclick: "jsKeyboard.del()", buttonClass: "button button_del", keyClass: "key", type:"BKSPC" },
            ]

    }
}


// GET CURSOR POSITION
jQuery.fn.getCursorPosition = function(){
    if(this.lengh == 0) return -1;
    return $(this).getSelectionStart();
}

jQuery.fn.getSelectionStart = function(){
    if(this.lengh == 0) return -1;
    input = this[0];

    var pos = input.value.length;

    if (input.createTextRange) {
        var r = document.selection.createRange().duplicate();
        r.moveEnd('character', input.value.length);
        if (r.text == '')
        pos = input.value.length;
        pos = input.value.lastIndexOf(r.text);
    } else if(typeof(input.selectionStart)!="undefined")
    pos = input.selectionStart;

    return pos;
}

//SET CURSOR POSITION
jQuery.fn.setCursorPosition = function(pos) {
  this.each(function(index, elem) {
    if (elem.setSelectionRange) {
      elem.setSelectionRange(pos, pos);
    } else if (elem.createTextRange) {
      var range = elem.createTextRange();
      range.collapse(true);
      range.moveEnd('character', pos);
      range.moveStart('character', pos);
      range.select();
    }
  });
  return this;
};